﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamTreeGridTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel vm = new ViewModel();
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = vm;
        }

        private void XamTreeGrid_RecordExpanded(object sender, Infragistics.Windows.DataPresenter.Events.RecordExpandedEventArgs e)
        {
            DataRecord record = e.Record as DataRecord;
            SampleData sd = record.DataItem as SampleData;

            foreach (SampleData child in sd.ActualChildData)
            {
                vm.Data.Add(child);
            }

            ((XamTreeGrid)sender).Records.RefreshSort();
        }

        private void XamTreeGrid_RecordCollapsed(object sender, Infragistics.Windows.DataPresenter.Events.RecordCollapsedEventArgs e)
        {
            DataRecord record = e.Record as DataRecord;
            SampleData sd = record.DataItem as SampleData;

            foreach(SampleData child in sd.ActualChildData)
            {
                if (vm.Data.Contains(child))
                {
                    vm.Data.Remove(child);
                }
            }

            ((XamTreeGrid)sender).Records.RefreshSort();
        }
    }
}
