﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamTreeGridTest
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for(int i=0; i<100; i++)
            {
                if (i % 3 == 0)
                {
                    SampleData SD = new SampleData()
                    {
                        ID = i,
                        Label = "Label " + i.ToString(),
                        Number = r.Next(1000),
                        ShouldHaveChildren = true,
                        ActualChildData = new ObservableCollection<SampleData>(),
                        DummyChildData = new ObservableCollection<SampleData>() { new SampleData() { IsDummy = true } }
                    };

                    for(int j = 0; j<5; j++)
                    {
                        SD.ActualChildData.Add(new SampleData()
                        {
                            ID = int.Parse(i.ToString() + j.ToString()),
                            Label = "ChildData " + i.ToString() + j.ToString(),
                            Number = r.Next(1000),
                            ShouldHaveChildren = false
                        });                        
                    }

                    Data.Add(SD);
                }
                else
                {
                    Data.Add(new SampleData()
                    {
                        ID = i,
                        Label = "Label " + i.ToString(),
                        Number = r.Next(1000),
                        ShouldHaveChildren = true
                    });
                }
            }
        }
    }

    public class SampleData : INotifyPropertyChanged
    {
        public int ID { get; set; }
        public string Label { get; set; }
        public int Number { get; set; }
        public bool ShouldHaveChildren { get; set; }
        public bool IsDummy { get; set; }
        public ObservableCollection<SampleData> ActualChildData { get; set; }
        public ObservableCollection<SampleData> DummyChildData { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
